public bool CopyGridExtent(Document doc, View sourceView, Reference selectedGrid) { DatumPlane selectedDatum = doc.GetElement(selectedGrid) as DatumPlane; Curve baseCurve = selectedDatum.GetCurvesInView(DatumExtentType.ViewSpecific, sourceView).ElementAt(0); XYZ basePoint0 = baseCurve.GetEndPoint(0); XYZ basePoint1 = baseCurve.GetEndPoint(1); Line baseLine = baseCurve as Line; Curve newCurve = selectedDatum.GetCurvesInView(DatumExtentType.ViewSpecific, doc.ActiveView).ElementAt(0); XYZ newCurvePt = newCurve.GetEndPoint(0); Line newLine = newCurve as Line; //sb.AppendLine("Source view end0 " + baseLine.GetEndPoint(0).X.ToString() + " - " + baseLine.GetEndPoint(0).Y.ToString() + " - " + baseLine.GetEndPoint(0).Z.ToString()); //sb.AppendLine("Active view end0 " + newLine.GetEndPoint(0).X.ToString() + " - " + newLine.GetEndPoint(0).Y.ToString() + " - " + newLine.GetEndPoint(0).Z.ToString()); //sb.AppendLine("Source view end1 " + baseLine.GetEndPoint(1).X.ToString() + " - " + baseLine.GetEndPoint(1).Y.ToString() + " - " + baseLine.GetEndPoint(1).Z.ToString()); //sb.AppendLine("Active view end1 " + newLine.GetEndPoint(1).X.ToString() + " - " + newLine.GetEndPoint(1).Y.ToString() + " - " + newLine.GetEndPoint(1).Z.ToString()); ISet <ElementId> par = new List <ElementId>() as ISet <ElementId>; View destination = doc.ActiveView; ViewPlan vp = destination as ViewPlan; PlanViewRange pvr = vp.GetViewRange(); Level l = vp.GenLevel; double zLevel = pvr.GetOffset(PlanViewPlane.CutPlane) + l.Elevation; //Z point for Datum curve //Curve projectedCurve = Line.CreateBound(new XYZ(basePoint0.X, basePoint0.Y, newCurvePt.Z), new XYZ(basePoint1.X, basePoint1.Y, newCurvePt.Z)); Curve projectedCurve = Line.CreateBound(new XYZ(basePoint0.X, basePoint0.Y, zLevel), new XYZ(basePoint1.X, basePoint1.Y, zLevel)); //par.Add(destination); //TaskDialog.Show("r", par.Count.ToString()); Grid g = doc.GetElement(selectedGrid) as Grid; //g.SetDatumExtentType(DatumEnds.End1, destination, DatumExtentType.ViewSpecific); g.SetCurveInView(g.GetDatumExtentTypeInView(DatumEnds.End1, sourceView), destination, projectedCurve); //TaskDialog.Show("r", sb.ToString()); //g.PropagateToViews(source, par); return(true); }
public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { UIDocument uidoc = commandData.Application.ActiveUIDocument; Document doc = uidoc.Document; try { ReferenceArray GridsRefRow = new ReferenceArray(); ReferenceArray GridsRefCol = new ReferenceArray(); XYZ TopPoint = null; XYZ LeftPoint = null; foreach (ElementId elemId in uidoc.Selection.GetElementIds()) { Element SelectedElem = doc.GetElement(elemId); if (SelectedElem is DatumPlane) { DatumPlane xGrid = SelectedElem as DatumPlane; IList <Curve> CurvesInGrid = xGrid.GetCurvesInView(DatumExtentType.ViewSpecific, uidoc.ActiveView); Curve cv = CurvesInGrid.First(); // only one segment grids allowed XYZ cvStart = cv.GetEndPoint(0); XYZ cvEnd = cv.GetEndPoint(1); if (Convert.ToInt32(cvStart.Y) == Convert.ToInt32(cvEnd.Y)) // then its a horizontal line, need to round the double bc the comparison will never work { GridsRefRow.Append(new Reference(xGrid)); if (LeftPoint is null && cvStart.X < cvEnd.X) // drawn left to right, keep start X---------> { LeftPoint = cvStart; } else if (LeftPoint is null && cvStart.X > cvEnd.X) // drawn right to left, keep end <---------X { LeftPoint = cvEnd; } } else if (Convert.ToInt32(cvStart.X) == Convert.ToInt32(cvEnd.X)) // then its a vertical { GridsRefCol.Append(new Reference(xGrid)); if (TopPoint is null && cvStart.Y < cvEnd.Y) // drawn bottom to top, keep end { TopPoint = cvEnd; } else if (TopPoint is null && cvStart.Y > cvEnd.Y) // drawn top to bottom, keep start { TopPoint = cvStart; } } } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { try { Document document = commandData.Application.ActiveUIDocument.Document; Autodesk.Revit.DB.View view = commandData.Application.ActiveUIDocument.ActiveView; datumDic.Clear(); ICollection <ElementId> datums = commandData.Application.ActiveUIDocument.Selection.GetElementIds(); if (datums == null || datums.Count == 0) { return(Result.Cancelled); } foreach (ElementId datumRef in datums) { DatumPlane datum = document.GetElement(datumRef) as DatumPlane; if (!datumDic.Keys.Contains(datum.Name)) { datumDic.Add(datum.Name, datum); } } //// Show UI using (AlignmentSetting settingForm = new AlignmentSetting()) { if (settingForm.ShowDialog() == DialogResult.OK) { DatumPlane selectedDatum = datumDic[settingForm.datumList.SelectedItem.ToString()]; Curve baseCurve = selectedDatum.GetCurvesInView(DatumExtentType.ViewSpecific, view).ElementAt(0); Line baseLine = baseCurve as Line; XYZ baseDirect = baseLine.Direction; using (Transaction tran = new Transaction(document, "DatumAlignment")) { tran.Start(); foreach (DatumPlane datum in datumDic.Values) { Curve curve = datum.GetCurvesInView(datum.GetDatumExtentTypeInView(DatumEnds.End0, view), view).ElementAt(0); XYZ direct = (curve as Line).Direction; Curve newCurve = CalculateCurve(curve, baseLine, baseDirect); datum.SetCurveInView(datum.GetDatumExtentTypeInView(DatumEnds.End0, view), view, newCurve); } tran.Commit(); } } } return(Result.Succeeded); } catch (Exception ex) { message = ex.Message; return(Result.Failed); } }
public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { UIDocument uidoc = commandData.Application.ActiveUIDocument; Document doc = uidoc.Document; try { using (Transaction t = new Transaction(doc, "Correct grid bubbles")) { t.Start(); foreach (ElementId elemId in uidoc.Selection.GetElementIds()) { Element SelectedElem = doc.GetElement(elemId); if (SelectedElem is DatumPlane) { DatumPlane xGrid = SelectedElem as DatumPlane; IList <Curve> CurvesInGrid = xGrid.GetCurvesInView(DatumExtentType.ViewSpecific, uidoc.ActiveView); Curve cv = CurvesInGrid.First(); // only one segment grids allowed XYZ cvStart = cv.GetEndPoint(0); XYZ cvEnd = cv.GetEndPoint(1); XYZ cvTop = null; XYZ cvLeft = null; #region FIND TOP AND LEFT if (Convert.ToInt32(cvStart.Y) == Convert.ToInt32(cvEnd.Y)) // then its a horizontal line { if (cvStart.X < cvEnd.X) // drawn left to right, keep start X---------> { cvLeft = cvStart; } else if (cvStart.X > cvEnd.X) // drawn right to left, keep end <---------X { cvLeft = cvEnd; } } else if (Convert.ToInt32(cvStart.X) == Convert.ToInt32(cvEnd.X)) // then its a vertical { if (cvStart.Y < cvEnd.Y) // drawn bottom to top, keep end { cvTop = cvEnd; } else if (cvStart.Y > cvEnd.Y) // drawn top to bottom, keep start { cvTop = cvStart; } } #endregion // Use top and left, and start and end to find which endpoint to turn on if ((cvLeft != null && cvLeft.IsAlmostEqualTo(cvStart)) || (cvTop != null && cvTop.IsAlmostEqualTo(cvStart))) // the grid was drawn correctly { xGrid.ShowBubbleInView(DatumEnds.End0, uidoc.ActiveView); xGrid.HideBubbleInView(DatumEnds.End1, uidoc.ActiveView); } else if ((cvLeft != null && cvLeft.IsAlmostEqualTo(cvEnd)) || cvTop != null && cvTop.IsAlmostEqualTo(cvEnd)) // the grid was drawn the other way around { xGrid.ShowBubbleInView(DatumEnds.End1, uidoc.ActiveView); xGrid.HideBubbleInView(DatumEnds.End0, uidoc.ActiveView); } } } t.Commit(); } return(Result.Succeeded); } catch (Exception ex) { Utils.CatchDialog(ex); return(Result.Failed); } }